This is a bridge for fusion in jimu

## install

![install](https://nodei.co/npm/jimu-bridge.png)

## Usage

~~~javascript
import bridgeApi from 'jimu-bridge'

// bridgeApi ready 
bridgeApi.ready(function(){
  	bridgeApi.setTitle('jimu-bridge')
})

// bridgeApi use
bridgeApi.setTitle('jimu-bridge') 

~~~

## API

>callback  端的回调函数，一般是指端调用结束后，返回h5回调函数，以下若无特别说明，都是指端的回调函数。

|            名称            |                   使用方式                   |                参数说明                 |          功能           |
| :----------------------: | :--------------------------------------: | :---------------------------------: | :-------------------: |
|         setTitle         |        bridgeApi.setTitle(title)         |         **title** string对象          |    设置webview的页面标题     |
|     getLocationInfo      |   bridgeApi.getLocationInfo(callback)    |                  /                  |       获取当前位置信息        |
|       getUserInfo        |     bridgeApi.getUserInfo(callback)      |                  /                  |       获取用户信息，例如       |
|         getSign          |  bridgeApi.getSign(urlparam, callback)   |      **urlparm** string url字符串      |      获取url字符串的签名      |
|        jumpError         |          bridgeApi.jumpError()           |                  /                  |   华为获取信息失败跳转, 回退到端    |
|       quitWebview        |          bridgeApi.quitWebview()         |                  /                  |   回退到端  同（jumpError）|
|       jumpSuccess        |       bridgeApi.jumpSuccess(param)       |         **param** object对象          |       华为状态成功跳转        |
|        getAddress        |  bridgeApi.getAddress(param, callback)   |         **param** object对象          |       跳转到端地址选择页       |
|      openNewWindow       |      bridgeApi.openNewWindow(param)      |         **param** object对象          |         打开新窗口         |
|  openFellowTravelerPage  | bridgeApi.openFellowTravelerPage(param)  |         **param** object对象          |       进入端内的同路人页       |
|         startIM          |         bridgeApi.startIM(param)         |         **param** object对象          |       调起端的IM窗口        |
|     showConversation     |    bridgeApi.showConversation(param)     |         **param** object对象          |  调起或隐藏native的IM列表入口   |
| startCollectLocationData | bridgeApi.startCollectLocationData(param) |        **param** string 手机号         |         采集坐标点         |
|     enterForeground      |   bridgeApi.enterForeground(callback)    |                  /                  |        后端唤起app        |
|        playAudio         |        bridgeApi.playAudio(param)        |         **param** object对象          |         播放语音          |
|          share           |          bridgeApi.share(param)          |         **param** object对象          |         分享到微信         |
|      getShowbutton       |      bridgeApi.getShowbutton(param)      |       **param** string，右上角名称        |       显示右上角的问题        |
|  pressBackToExitWebView  |    bridgeApi.pressBackToExitWebView()    |                  /                  |   后退事件 webview直接退出    |
|     showOrderDetail      |     bridgeApi.showOrderDetail(param)     |         **param** object对象          |       调起订单的端内页        |
|  rightNavButtonClicked   | bridgeApi.rightNavButtonClicked(callback) |                  /                  |      右上角按钮的注册方法       |
|        pushNotify        |      bridgeApi.pushNotify(callback)      |                  /                  |        push通知         |
|     setH5LocalCache      |  bridgeApi.setH5LocalCache(key, value)   | **key** string对象 **value** string对象 | 以(key, value)的形式存储到端中 |
|     getH5LocalCache      | bridgeApi.getH5LocalCache(key, callback) |          **key** string对象           |     获取key对应的value     |
|     startAvatarAction    | bridgeApi.startAvatarAction(param, callback) |        **param** object对象           |     调起端的相机和相册     |
|     loginSuccess        | bridgeApi.loginSuccess(token, company_ruler) | **param** "company_ruler","1表示普通乘客角色 2表示管理员角色"  |     通知端 自动登录     |
|     openApprovalHistory    | bridgeApi.openApprovalHistory(param, callback) |        **param**            |     打开差旅历史列表     |
|     openScheduleHistory    | bridgeApi.openScheduleHistory(param, callback) |        **param**            |     申请历史     |
|     openSctxHistory        | bridgeApi.openSctxHistory(param, callback) |        **param**            |     打开私车同行的审批历史页面    |
|     getContacts    | bridgeApi.getContacts(param, callback) |        **param**            |     获取用户通讯录     |
|    faceRecognition | bridgeApi.faceRecognition(param, callback) |     **param**    |  人脸识别，需要先实名认证，方可认证     |
|  setTitleBarColor  | bridgeApi.setTitleBarColor(param, callback)|    **param**     |  设置app的bar color     |
|  setStatusBarColor | bridgeApi.setStatusBarColor(param, callback) |    **param**   |   设置系统的状态栏 color  |
|  setComplaintStatus | bridgeApi.setComplaintStatus(param, callback) |    **param**   |   设置端内投诉状态  |
|  openSchema | bridgeApi.openSchema(app_schema) |    **app_schema**  string对象 业务线列表 http://wiki.intra.xiaojukeji.com/pages/viewpage.action?pageId=13861156 |   打开滴滴出行APP的功能   |
|  payByWX | bridgeApi.payByWX(param, callback) |    **param** |   微信支付   |
|  payByAli | bridgeApi.payByAli(param, callback) |    **param** |   支付宝支付   |
|  setupRightNaviBarMenu | bridgeApi.setupRightNaviBarMenu(paramArr) |    **param** |   设置app右上角菜单   |
|  getApollo | bridgeApi.getApollo(param, callback) |    **param** |   获取apollo信息 apolloConfigParam key值   |
|  getDeviceInfo | bridgeApi.getDeviceInfo(callback) |    **callback** |   获取设备信息   |
|  copyText | bridgeApi.copyText(param) |    **param** |   复制   |
|  on_submit_callback | bridgeApi.on_submit_callback(param) |    **param** |   成本中心用车备注   |
|  getEstimatePrice | bridgeApi.getEstimatePrice(param) |    **callback** |   获取预估价返回信息   |
|  changePayStyle | bridgeApi.changePayStyle(param) |    **pay_style_name, pay_style, callback** |   更改支付方式   |
|  carDiversion | bridgeApi.carDiversion(param) |    **param 专车还是快车**   |   专车导流   |
|  clearCache | bridgeApi.clearCache(callback) |    **callback**   |   清空缓存   |
|  identifyIBMStaffInfo | bridgeApi.identifyIBMStaffInfo(callback) |    **callback**   |   认证IBM员工   |
|  callNativeLogin | bridgeApi.callNativeLogin() |      |   调起 App 的登录页   |

## License

jimu-bridge is released under the MIT license.