"use strict";
const webpack = require('webpack');
const path = require('path')

const ExtractTextPlugin = require('extract-text-webpack-plugin');

// Create multiple instances
const ExtractCSS = new ExtractTextPlugin('styles.css');
const HtmlWebpackPlugin = require('html-webpack-plugin')

let autoprefixer = require('autoprefixer');
let precss = require('precss')

module.exports = {
  devtool: 'cheap-module-source-map',//生成map文件
  context: path.resolve(__dirname, "example"),
  entry: {
    'main': './index',
  },
  output: {
    filename: 'dist/[name].js',
    chunkFilename: "dist/[id].[name].js",
    path: path.resolve(__dirname, 'dist'),
    publicPath: '/'
  },
  module:{
    rules: [
      {
        test: /\.(js|jsx)$/,
        use: [{
          loader: "babel-loader",
       }],
      }
    ],
  },
  resolve: {
    extensions: ['.js'],
    modules: [path.resolve(__dirname, "example"), "node_modules"]
  },
  plugins: [
    new webpack.LoaderOptionsPlugin({
      options: {
        postcss: function () {
          return [precss, autoprefixer];
        }
      }
    }),
    new webpack.HotModuleReplacementPlugin(),
    new HtmlWebpackPlugin({
      template: './index.html',
      filename: 'index.html'
    })
  ]
}
